part of disposable;

// TODO: Implement RefCountDisposable - https://github.com/Reactive-Extensions/RxJS/blob/master/rx.js
// TODO: Implement ScheduledDisposable - https://github.com/Reactive-Extensions/RxJS/blob/master/rx.js

class Disposable implements IDisposable {
  static dynamic noop = () { };
  final Function _callback;
  bool _isDisposed = false;
  bool get isDisposed => _isDisposed;

  /*
   * Creates a disposable instance which triggers (if provided) the supplied callback
   */
  Disposable([void callback()])
      : this._callback = callback != null ? callback : Disposable.noop;

  /*
   * Triggers the cleanup callback provided to the disposable
   * Dispose cannot be called multiple times on the same instance
   */
  void dispose() {
    if(_isDisposed) { return; }
    _isDisposed = true;
    _callback();
  }
}